{"openapi":"3.0.1","info":{"title":"OpenAPI definition","version":"v0"},"servers":[{"url":"http://apps.lifs-tools.org/goslin","description":"Generated server url"}],"paths":{"/rest/validate":{"post":{"tags":["lipid-name-validation"],"operationId":"validate","requestBody":{"content":{"application/json":{"schema":{"$ref":"#/components/schemas/ValidationRequest"}}},"required":true},"responses":{"200":{"description":"OK","content":{"*/*":{"schema":{"$ref":"#/components/schemas/ValidationResults"}}}}}}},"/rest/lipidlevels":{"get":{"tags":["lipid-levels"],"operationId":"lipidLevels","responses":{"200":{"description":"OK","content":{"*/*":{"schema":{"type":"array","items":{"type":"string","enum":["NO_LEVEL","UNDEFINED_LEVEL","CATEGORY","CLASS","SPECIES","MOLECULAR_SPECIES","SN_POSITION","STRUCTURE_DEFINED","FULL_STRUCTURE","COMPLETE_STRUCTURE"]}}}}}}}},"/rest/grammars":{"get":{"tags":["lipid-grammars"],"operationId":"grammars","responses":{"200":{"description":"OK","content":{"*/*":{"schema":{"type":"array","items":{"type":"string","enum":["GOSLIN","LIPIDMAPS","SWISSLIPIDS","HMDB","SHORTHAND","FATTY_ACID","NONE"]}}}}}}}},"/download/{sessionId}/{storageServiceSlot}":{"get":{"tags":["lipid-name-validation-controller"],"operationId":"getResults","parameters":[{"name":"sessionId","in":"path","required":true,"schema":{"type":"string"}},{"name":"storageServiceSlot","in":"path","required":true,"schema":{"type":"string"}}],"responses":{"200":{"description":"OK","content":{"*/*":{"schema":{"type":"string","format":"binary"}}}}}}}},"components":{"schemas":{"ValidationRequest":{"type":"object","properties":{"lipidNames":{"type":"array","items":{"type":"string"}},"grammars":{"type":"array","items":{"type":"string","enum":["GOSLIN","LIPIDMAPS","SWISSLIPIDS","HMDB","SHORTHAND","FATTY_ACID","NONE"]}},"skipInvalid":{"type":"boolean"}}},"Adduct":{"type":"object","properties":{"sumFormula":{"type":"string"},"adductString":{"type":"string"},"charge":{"type":"integer","format":"int32"},"chargeSign":{"type":"integer","format":"int32"},"heavyElements":{"type":"object","properties":{"sumFormula":{"type":"string"},"mass":{"type":"number","format":"double"},"empty":{"type":"boolean"}},"additionalProperties":{"type":"integer","format":"int32"}},"lipidString":{"type":"string"},"heavyIsotopeString":{"type":"string"}}},"DoubleBonds":{"type":"object","properties":{"numDoubleBonds":{"type":"integer","format":"int32"},"doubleBondPositions":{"type":"object","additionalProperties":{"type":"string"}}}},"ExternalDatabaseReference":{"type":"object","properties":{"databaseUrl":{"type":"string"},"databaseElementId":{"type":"string"},"lipidLevel":{"type":"string"},"nativeAbbreviation":{"type":"string"},"nativeName":{"type":"string"},"normalizedName":{"type":"string"}}},"FattyAcid":{"type":"object","properties":{"name":{"type":"string"},"position":{"type":"integer","format":"int32"},"count":{"type":"integer","format":"int32"},"doubleBonds":{"$ref":"#/components/schemas/DoubleBonds"},"stereoBound":{"type":"boolean"},"functionalGroups":{"type":"object","additionalProperties":{"type":"array","items":{"$ref":"#/components/schemas/FunctionalGroup"}}},"numCarbon":{"type":"integer","format":"int32"},"lipidFaBondType":{"type":"string","enum":["NO_FA","UNDEFINED_FA","ESTER","ETHER","ETHER_PLASMANYL","ETHER_PLASMENYL","ETHER_UNSPECIFIED","LCB_EXCEPTION","LCB_REGULAR","AMIDE"]},"unresolvedHiddenFa":{"type":"boolean"},"ndoubleBonds":{"type":"integer","format":"int32"},"type":{"type":"string","writeOnly":true,"enum":["NO_FA","UNDEFINED_FA","ESTER","ETHER","ETHER_PLASMANYL","ETHER_PLASMENYL","ETHER_UNSPECIFIED","LCB_EXCEPTION","LCB_REGULAR","AMIDE"]}}},"FunctionalGroup":{"type":"object","properties":{"name":{"type":"string"},"position":{"type":"integer","format":"int32"},"count":{"type":"integer","format":"int32"},"doubleBonds":{"$ref":"#/components/schemas/DoubleBonds"},"stereoBound":{"type":"boolean"},"ndoubleBonds":{"type":"integer","format":"int32"}}},"Headgroup":{"type":"object","properties":{"lipidCategory":{"type":"string","enum":["NO_CATEGORY","UNDEFINED","GL","GP","SP","ST","FA","PK","SL"]},"name":{"type":"string"},"lipidClass":{"type":"string"}}},"LipidAdduct":{"type":"object","properties":{"lipid":{"$ref":"#/components/schemas/LipidSpecies"},"adduct":{"$ref":"#/components/schemas/Adduct"},"lipidString":{"type":"string"},"extendedClass":{"type":"string"},"sumFormula":{"type":"string"},"lipidLevel":{"type":"string","enum":["NO_LEVEL","UNDEFINED_LEVEL","CATEGORY","CLASS","SPECIES","MOLECULAR_SPECIES","SN_POSITION","STRUCTURE_DEFINED","FULL_STRUCTURE","COMPLETE_STRUCTURE"]},"mass":{"type":"number","format":"double"},"className":{"type":"string"}}},"LipidSpecies":{"type":"object","properties":{"headGroup":{"$ref":"#/components/schemas/Headgroup"},"info":{"$ref":"#/components/schemas/LipidSpeciesInfo"},"faList":{"type":"array","items":{"$ref":"#/components/schemas/FattyAcid"}},"lipidString":{"type":"string"},"extendedClass":{"type":"string"},"lipidLevel":{"type":"string","enum":["NO_LEVEL","UNDEFINED_LEVEL","CATEGORY","CLASS","SPECIES","MOLECULAR_SPECIES","SN_POSITION","STRUCTURE_DEFINED","FULL_STRUCTURE","COMPLETE_STRUCTURE"]}}},"LipidSpeciesInfo":{"type":"object","properties":{"name":{"type":"string"},"position":{"type":"integer","format":"int32"},"count":{"type":"integer","format":"int32"},"doubleBonds":{"$ref":"#/components/schemas/DoubleBonds"},"stereoBound":{"type":"boolean"},"functionalGroups":{"type":"object","additionalProperties":{"type":"array","items":{"$ref":"#/components/schemas/FunctionalGroup"}}},"numCarbon":{"type":"integer","format":"int32"},"lipidFaBondType":{"type":"string","enum":["NO_FA","UNDEFINED_FA","ESTER","ETHER","ETHER_PLASMANYL","ETHER_PLASMENYL","ETHER_UNSPECIFIED","LCB_EXCEPTION","LCB_REGULAR","AMIDE"]},"unresolvedHiddenFa":{"type":"boolean"},"level":{"type":"string","enum":["NO_LEVEL","UNDEFINED_LEVEL","CATEGORY","CLASS","SPECIES","MOLECULAR_SPECIES","SN_POSITION","STRUCTURE_DEFINED","FULL_STRUCTURE","COMPLETE_STRUCTURE"]},"numEthers":{"type":"integer","format":"int32"},"numSpecifiedFa":{"type":"integer","format":"int32"},"possFa":{"type":"integer","format":"int32"},"totalFa":{"type":"integer","format":"int32"},"extendedClass":{"type":"string","enum":["NO_FA","UNDEFINED_FA","ESTER","ETHER","ETHER_PLASMANYL","ETHER_PLASMENYL","ETHER_UNSPECIFIED","LCB_EXCEPTION","LCB_REGULAR","AMIDE"]},"lipidClass":{"type":"integer","format":"int32"},"ndoubleBonds":{"type":"integer","format":"int32"},"type":{"type":"string","writeOnly":true,"enum":["NO_FA","UNDEFINED_FA","ESTER","ETHER","ETHER_PLASMANYL","ETHER_PLASMENYL","ETHER_UNSPECIFIED","LCB_EXCEPTION","LCB_REGULAR","AMIDE"]}}},"ValidationResult":{"type":"object","properties":{"lipidName":{"type":"string"},"grammar":{"type":"string","enum":["GOSLIN","LIPIDMAPS","SWISSLIPIDS","HMDB","SHORTHAND","FATTY_ACID","NONE"]},"messages":{"type":"array","items":{"type":"string"}},"lipidAdduct":{"$ref":"#/components/schemas/LipidAdduct"},"functionalGroupCounts":{"type":"object","additionalProperties":{"type":"integer","format":"int32"}},"normalizedName":{"type":"string"},"lipidMapsCategory":{"type":"string"},"lipidMapsClass":{"type":"string"},"lipidCategoryName":{"type":"string"},"lipidClassName":{"type":"string"},"lipidExtendedSpeciesName":{"type":"string"},"lipidSpeciesName":{"type":"string"},"lipidMolecularSpeciesName":{"type":"string"},"lipidSnPositionName":{"type":"string"},"lipidStructureDefinedName":{"type":"string"},"lipidFullStructureName":{"type":"string"},"lipidCompleteStructureName":{"type":"string"},"mass":{"type":"number","format":"double"},"sumFormula":{"type":"string"},"lipidMapsReferences":{"type":"array","items":{"$ref":"#/components/schemas/ExternalDatabaseReference"}},"swissLipidsReferences":{"type":"array","items":{"$ref":"#/components/schemas/ExternalDatabaseReference"}},"chebiReferences":{"type":"array","items":{"$ref":"#/components/schemas/ExternalDatabaseReference"}}}},"ValidationResults":{"type":"object","properties":{"results":{"type":"array","items":{"$ref":"#/components/schemas/ValidationResult"}},"totalReceived":{"type":"integer","format":"int64"},"totalParsed":{"type":"integer","format":"int64"},"failedToParse":{"type":"integer","format":"int64"}}}}}}